# Class DoubleList

java.lang.Object
uk.ac.starlink.util.PrimitiveList
uk.ac.starlink.util.DoubleList

public class DoubleList extends PrimitiveList
Extendable array of doubles.

Since:
  12 Oct 2006
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`DoubleList()`
Constructs a new list.
`DoubleList(double[] array)`
Constructs a new list initialised to the contents of a given array.
`DoubleList(int size)`
Constructs a new list with a given initial capacity.

## Method Summary

Modifier and Type
Method
Description
`void`
`add(double value)`
Appends a value to the end of this list.
`boolean`
`addAll(double[] array)`
Appends all the elements of a primitive array to this list.
`boolean`
`addAll(DoubleList other)`
Appends all the elements of a second list to this list.
`double`
`get(int i)`
Returns the element at a given position.
`double[]`
`getDoubleBuffer()`
Returns the array currently used to store the contents of this list.
`void`
`set(int i, double value)`
Sets the element at a given position.
`double[]`
`toDoubleArray()`
Returns the contents of this list as an array.

### Methods inherited from class PrimitiveList

`clear, nextCapacity, size, toArray`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### DoubleList

public DoubleList()
Constructs a new list.

### DoubleList

public DoubleList(int size)
Constructs a new list with a given initial capacity.

Parameters:
  `size` - initial capacity

### DoubleList

public DoubleList(double[] array)
Constructs a new list initialised to the contents of a given array.

Parameters:
  `array` - array whose contents form initial contents of list

## Method Details

### get

public double get(int i)
Returns the element at a given position.

Parameters:
  `i` - index
Returns:
  element at `i`

### set

public void set(int i, double value)
Sets the element at a given position.

Parameters:
  `i` - index
  `value` - new value for element `i`

### add

public void add(double value)
Appends a value to the end of this list.

Parameters:
  `value` - value to append

### addAll

public boolean addAll(DoubleList other)
Appends all the elements of a second list to this list.

Parameters:
  `other` - other list
Returns:
  true iff this collection changed as a result of the call

### addAll

public boolean addAll(double[] array)
Appends all the elements of a primitive array to this list.

Parameters:
  `array` - array to append
Returns:
  true iff this collection changed as a result of the call

### toDoubleArray

public double[] toDoubleArray()
Returns the contents of this list as an array.

Returns:
  copy of list contents

### getDoubleBuffer

public double[] getDoubleBuffer()
Returns the array currently used to store the contents of this list. Its length will be greater than or equal to the length of this list. The identity of the returned array may change as this list is mutated.

Returns:
  storage array